/**
 * @file tv_test.c
 * tv_test native device driver test.
 *
 * Copyright (c) 2008, Steve Denson
 * See end of file for terms of use.
 */
#include <ctype.h>
#include <stdlib.h>
#include <string.h>
#include <propeller.h>

#include "tvText.h"

void toggle(void) {
     OUTA ^= 1;
}

void main(void)
{
    int ii = 85;
    int jj = 0;

    tvText_start(20);  // start TV
    
    print("\nzoot ");

    print("color");
    tvText_setXY(0,0);
    print("Hi\n");
    print("zoot");
    tvText_setCoordPosition(1,3);
    print("abcd");
    tvText_setCurPosition(5,5);
    
    print("Hello World!\r");
    tvText_setY(tvText_getY()+1);
    tvText_str("Decimal ");
    tvText_dec(ii);
    tvText_setY(tvText_getY()+1);

    for(jj = 10; jj < 20; jj++) {
        tvText_setColors((jj-10));
        tvText_setXY(jj, jj % TV_TEXT_ROWS);
        tvText_str("0x");
        tvText_hex(ii++, 4);
    }
    
    DIRA |= 1;
    while(1) {
        toggle();
    }
}

/*
+------------------------------------------------------------------------------------------------------------------------------+
                                                   TERMS OF USE: MIT License                                                                                                              
+------------------------------------------------------------------------------------------------------------------------------
Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation     
files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,    
modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software
is furnished to do so, subject to the following conditions:                                                                   
                                                                                                                              
The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.
                                                                                                                              
THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE          
WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR         
COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,   
ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.                         
+------------------------------------------------------------------------------------------------------------------------------+
*/
