#include "propeller.h"

//int clkfreq = 104857600;
int clkfreq = 80000000;

int errno;

void* zalloc(int len)
{
  void* ptr = (void*) _syscall(&errno, SYS_huballoc, len, 0, 0);
  return ptr;
}

void zfree(void* ptr)
{
  _syscall(&errno, SYS_hubfree, ptr, 0, 0);
}

void longfill(int* dst, int fill, int count)
{
  while(--count >= 0) {
    *(dst++) = fill;
  }
}

void longmove(int* dst, int* src, int count)
{
#ifdef DUMP_LONGMOVE
  int n = 0;
#endif
  while(--count >= 0) {
    *(dst++) = *(src++);
#ifdef DUMP_LONGMOVE
    if((n % 8) == 0) iprintf("\n%08x ", (dst-1));
    iprintf("%08x ", *(dst-1));
    n++;
#endif
  }
}

int cognew(int* code, int* par)
{
  int cog;
  cog = _syscall(&errno, SYS_cognew, 0, code, par);
  return (cog);
}

int coginit(int cog, int* code, int* par)
{
  cog = _syscall(&errno, SYS_coginit, cog, code, par);
  return (cog);
}

void cogstop(int cog)
{
  int result;
  result = _syscall(&errno, SYS_cogstop, cog, 0, 0);
}
